/*
    protocols.c: where all good routines are!
    Copyright (C) 1999 by Marcelo Gornstein

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    see "COPYING" file for details.

If you want to contact me:
Marcelo Gornstein
mgornstein@usa.net
*/
#include <net/if.h>
#include <net/ethernet.h>

extern void log (int fd, char *str_to_log, char log_time);
extern int fd;

#if LOG_MAC_ADDRESSES
void log_macs (struct ethhdr e)
{
char aux [100];
memset (aux, '\0', sizeof (aux));
#if LOG_SRC_ADDRESS
sprintf (aux, "source MAC address: %x:%x:%x:%x:%x:%x\n", e.h_source[0],
                                                        e.h_source[1],
                                                        e.h_source[2],
                                                        e.h_source[3],
                                                        e.h_source[4],
                                                        e.h_source[5]);
log (fd, aux, 0);
#endif

#if LOG_DST_ADDRESS
memset (aux, '\0', sizeof (aux));
sprintf (aux, "target MAC address: %x:%x:%x:%x:%x:%x\n", e.h_dest[0],
                                                        e.h_dest[1],
                                                        e.h_dest[2],
                                                        e.h_dest[3],
                                                        e.h_dest[4],
                                                        e.h_dest[5]);
log (fd, aux, 0);
#endif
}

#endif

#if LOG_IP_ADDRESSES

void log_ip (struct iphdr i)
{
char aux [100];
memset (aux, '\0', sizeof (aux));

#if LOG_SRC_IP
sprintf (aux, "source IP address: %s\n", inet_ntoa (i.saddr));
log (fd, aux, 0);
#endif

#if LOG_DST_IP
sprintf (aux, "Target IP address: %s\n", inet_ntoa (i.daddr));
log (fd, aux, 0);
#endif
}
#endif

#if UDP
void listen_udp (struct udphdr u)
{
int j;
char aux [100];

for (j = 0; j < sizeof (LOG_DST_PORTS)/4; j++)
{
if (ntohs(u.dest) == LOG_DST_PORTS[j])
        {
        log (fd, "Packet!\n", 1);
        #if LOG_SRC_PORT
		memset (aux, '\0', sizeof (aux));
                sprintf (aux, "source udp port: %d\n",ntohs (u.source));
                log (fd, aux, 0);
        #endif
        #if LOG_DST_PORT
                memset (aux, '\0', sizeof (aux));
		sprintf (aux, "target udp port: %d\n",ntohs (u.dest));
                log (fd, aux, 0);
        #endif

        }
}
for (j = 0; j < sizeof (LOG_SRC_PORTS)/4; j++)
{
if (ntohs(u.dest) == LOG_SRC_PORTS[j])
        {
        log (fd, "Packet!\n", 1);
        #if LOG_SRC_PORT
		memset (aux, '\0', sizeof (aux));
                sprintf (aux, "source udp port: %d\n",ntohs (u.source));
                log (fd, aux, 0);
        #endif
        #if LOG_DST_PORT
                memset (aux, '\0', sizeof (aux));
		sprintf (aux, "target udp port: %d\n",ntohs (u.dest));
                log (fd, aux, 0);
        #endif

        }
}
}
#endif

#if TCP
void listen_tcp (struct tcphdr t)
{
int j;
char aux [100];

for (j = 0; j < sizeof (LOG_DST_PORTS)/4; j++)
{
if ((ntohs(t.dest) == LOG_DST_PORTS[j]) && t.syn)
        {
        log (fd, "Packet!\n", 1);
        #if LOG_SRC_PORT
		memset (aux, '\0', sizeof (aux));
                sprintf (aux, "source tcp port: %d\n",ntohs (t.source));
                log (fd, aux, 0);
        #endif
        #if LOG_DST_PORT
                memset (aux, '\0', sizeof (aux));
		sprintf (aux, "target tcp port: %d\n",ntohs (t.dest));
                log (fd, aux, 0);
        #endif

        }
}
for (j = 0; j < sizeof (LOG_SRC_PORTS)/4; j++)
{
if ((ntohs(t.dest) == LOG_SRC_PORTS[j]) && t.syn)
        {
        log (fd, "Packet!\n", 1);
        #if LOG_SRC_PORT
		memset (aux, '\0', sizeof (aux));
                sprintf (aux, "source tcp port: %d\n",ntohs (t.source));
                log (fd, aux, 0);
        #endif
        #if LOG_DST_PORT
                memset (aux, '\0', sizeof (aux));
		sprintf (aux, "target tcp port: %d\n",ntohs (t.dest));
                log (fd, aux, 0);
        #endif

        }
}
}
#endif


